{{
************************************************************************************************
PROP2CPLD new short demo.
This code is for the Prop2Cpld board.
By Alberto Geraci - BTX Sistemas - Argentina
This code lets you know more or less how this board works.
************************************************************************************************
}}
CON
        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000

        BTR       = 6144    ' Packet size
        Pin       = 24
        Frequency = 100_700_000 '100.7MHz CPLD clk

        Black     = $00000000
        White     = $FFFEFFFE
        Blue      = $003E003E
        Red       = $F800F800
        Green     = $07C007C0

obj
   Freq      : "Synth"
   cpld_data : "CPLD_Driver"       
   sdfat     : "fsrw"
      
var
   byte Buffer[6144]
   long FrameData_RGB[1536]
   long  col, row, color, flag, BackSpaceColor, nfont, cols, rows, screensize, lastrow
   byte textbuf[40]

pub start | i, j, x, y, k

   Freq.Synth(Pin, Frequency)               ' CPLD clk          

   outa[6]:=0
   dira[6]~~

   outa[6]:=1                               ' CPLD reset
   waitcnt(clkfreq/8+cnt)
   outa[6]:=0

   outa[8..23]:=0
   dira[8..23]~~

   outa[30]:=0
   dira[30]~~

   outa[4]:=0
   dira[4]~

   cpld_data.start(@FrameData_RGB)
   waitcnt(clkfreq/16+cnt)
   sdfat.mount(0)                          ' 
   waitcnt(clkfreq/16+cnt)

   BackSpaceColor := Black
   BackGround(Blue)
   BackSpaceColor := Blue

          waitcnt(clkfreq*4 + cnt)          
             repeat i from 10 to 470                     'White lines
               y:= i
               Plot(10,y,$FFFEFFFE,1)
             repeat i from 10 to 470
               y:= i
               Plot(630,y,$FFFEFFFE,1)
             repeat i from 10 to 630
               y:= i
               Plot(y,10,$FFFEFFFE,1)
             repeat i from 10 to 630
               y:= i
               Plot(y,470,$FFFEFFFE,1)

          Show(string("car.btx"),50,230,20,153)           'Orange Car
          j:=0
          repeat i from 0 to 60 step 2                    'Shadow
            j++
            FastLoad(280+j/4,1,20+j/4,153,$00000000+i)
          j:=0
          repeat i from 0 to 60 step 2                    'Shadow
            j++
            FastLoad(50+j/4,230,173+j/4,1,$00000000+i)

          j:=0                                            'Mixed Color cube 
          repeat i from 0 to 1920 step 64
            j++
            waitcnt(clkfreq/32 + cnt)           
            FastLoad(450+j,80,60+j,80,$0000F800+i)

          Font(1)
          out($0A)
          out(25)
          out($0B)
          out(13)
          str(string("Prop2Cpld"))    
          out($0A)
          out(24)
          out($0B)
          out(15)
          str(string("New - Short"))    
          out($0A)
          out(24)
          out($0B)
          out(17)
          str(string("   Demo"))    

             repeat i from 0 to 63488 step 2048           'Fade Text window
                waitcnt(clkfreq/32 + cnt)           
                FastLoad(150,230,220,80,$0000003E+i)
             Font(1)
             out($0A)
             out(10)
             out($0B)
             out(15)
             str(string("Hello BTX !",13))    
             Font(0)
             out($0A)
             out(22)
             out($0B)
             out(24)
             str(string("Testing both Fonts....",13))     
             waitcnt(clkfreq*1 + cnt)           

          j:=0                                            'Background of the following fonts
          repeat i from 0 to 120 'step 2                       '
            j++
            FastLoad(20,600,330+j,10,$00000000+i)

        Font(0)
        out($0A)
        out(10)
        out($0B)
        out(30)
        str(string(" abcdefghijklmnopqrstuvwxyz"))      '
        out($0A)
        out(10)
        out($0B)
        out(31)
        str(string(" ABCDEFGHIJKLMNOPQRSTUVWXYZ"))      '
        out($0A)
        out(10)
        out($0B)
        out(32)
        str(string(" !@#$%&()'*+,-.:;<=>?"))     '
        Font(1)
        out($0A)
        out(4)
        out($0B)
        out(23)
        str(string(" abcdefghijklmnopqrstuvwxyz"))      '
        out($0A)
        out(4)
        out($0B)
        out(24)
        str(string(" ABCDEFGHIJKLMNOPQRSTUVWXYZ"))      '
        out($0A)
        out(4)
        out($0B)
        out(25)
        str(string(" !@#$%&()'*+,-.:;<=>?"))     '

        out($0A)
        out(13)
        out($0B)
        out(27)
        str(string("Overlay Text"))     '

          repeat
             repeat i from 0 to 63488 step 2048           'Fade Text window
                waitcnt(clkfreq/32 + cnt)           
                FastLoad(150,230,220,80,$0000003E+i)
             Font(1)
             out($0A)
             out(10)
             out($0B)
             out(15)
             str(string("Hello BTX !",13))    
             Font(0)
             out($0A)
             out(22)
             out($0B)
             out(24)
             str(string("Testing both Fonts....",13))     
             waitcnt(clkfreq*1 + cnt)           
             repeat i from 0 to 63488 step 2048           'Fade Text window
                waitcnt(clkfreq/32 + cnt)           
                FastLoad(150,230,220,80,$0000003E+63488-i)

'
PUB FastLoad(Begin_in_width,Width,Begin_in_Height,Height,fcolor)  | r, times, i, j, timesfict
          waitpeq(|<4,|<4,0)
          FrameData_RGB[0]:= Begin_in_width + 16384
          FrameData_RGB[1]:= Width
          FrameData_RGB[2]:= Begin_in_Height
          FrameData_RGB[3]:= Height
          FrameData_RGB[4]:= 1
          FrameData_RGB[5]:= (Width*Height)
          outa[30]:=1
          outa[30]:=0

          waitpeq(|<4,|<4,0)
          longfill(@FrameData_RGB,$00000000,1)
          FrameData_RGB[0]:= fcolor
          outa[30]:=1
          outa[30]:=0

PUB Show(Read_in_Buffer,Begin_in_width,Width,Begin_in_Height,Height)  | r, times, i, j, timesfict

          times := (Width*Height*2)/BTR
          j:=0
          repeat times
            j:=j+6144
          if j<>(Width*Height*2)
            times:=times+1
            timesfict:=times+128
          else
            timesfict:=times
            
          if times==0    
             times:= 1
             timesfict:=129
          '****************************************************************************    
          waitpeq(|<4,|<4,0)
          FrameData_RGB[0]:= Begin_in_width
          FrameData_RGB[1]:= Width
          FrameData_RGB[2]:= Begin_in_Height
          FrameData_RGB[3]:= Height
          FrameData_RGB[4]:= timesfict
          FrameData_RGB[5]:= (Width*Height)

          outa[30]:=1
          outa[30]:=0

          r := sdfat.popen(Read_in_Buffer, "r")
          if r==-1
             Return
          else
            repeat times
               r := sdfat.pread(@Buffer, BTR)   ' Read the SD file.  
               waitpeq(|<4,|<4,0)
               longmove(@FrameData_RGB,@Buffer,1536)
               outa[30]:=1
               outa[30]:=0
'         **********************************************************************
'
PUB Plot(x,y,pcolor,transp)  | r
          waitpeq(|<4,|<4,0)
          if transp
              FrameData_RGB[0]:= x + 32768
          else
              FrameData_RGB[0]:= x 
          FrameData_RGB[1]:= 3
          FrameData_RGB[2]:= y
          FrameData_RGB[3]:= 3
          FrameData_RGB[4]:= 129
          FrameData_RGB[5]:= 9
          outa[30]:=1
          outa[30]:=0

          waitpeq(|<4,|<4,0)
          longfill(@FrameData_RGB,$00000000,5)
          FrameData_RGB[2]:= pcolor
          outa[30]:=1
          outa[30]:=0


PUB BackGround(pcolor) | r

          FastLoad(0,640,0,480,pcolor)
          
PUB BackSpace(pcolor) | r

          waitpeq(|<4,|<4,0)
          FrameData_RGB[0]:= col*8
          FrameData_RGB[1]:= 8
          FrameData_RGB[2]:= row*11
          FrameData_RGB[3]:= 11
          FrameData_RGB[4]:= 129
          FrameData_RGB[5]:= 88
          outa[30]:=1
          outa[30]:=0

          waitpeq(|<4,|<4,0)
          longfill(@FrameData_RGB,pcolor,1536)
          outa[30]:=1
          outa[30]:=0

'***********************************************************************************************
'***********************************************************************************************
'**        Text rutines   (Same as TV_Text but with minimals modifications)                                                                    **
'***********************************************************************************************
'***********************************************************************************************
PUB Font(x)  | i        ' Select the font to be used
   case x
      0:
        cols := 80     '28
        rows := 43     '18
        nfont := 0
        repeat i from 1 to 5
          textbuf[i] := byte[string("b.btx")+i-1]  
      1:
        cols := 40     
        rows := 30     
        nfont := 1
        repeat i from 1 to 5
          textbuf[i] := byte[string("d.btx")+i-1]  

   screensize := cols * rows
   lastrow    := screensize - cols

PUB str(stringptr)

'' Print a zero-terminated string

  repeat strsize(stringptr)
    out(byte[stringptr++])

PUB dec(value) | i

'' Print a decimal number

  if value < 0
    -value
    out("-")

  i := 1_000_000_000

  repeat 10
    if value => i
      out(value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      out("0")
    i /= 10

PUB hex(value, digits)

'' Print a hexadecimal number

  value <<= (8 - digits) << 2
  repeat digits
    out(lookupz((value <-= 4) & $F : "0".."9", "A".."F"))

PUB bin(value, digits)

'' Print a binary number

  value <<= 32 - digits
  repeat digits
    out((value <-= 1) & 1 + "0")

PUB out(c) | i, k

'' Output a character
''
''     $00 = clear screen
''     $01 = home
''     $08 = backspace
''     $09 = tab (8 spaces per)
''     $0A = set X position (X follows)
''     $0B = set Y position (Y follows)
''     $0C = set color (color follows)
''     $0D = return
''  others = printable characters

  case flag
    $00: case c
           $00: BackGround(Black)
                col := row := 0
           $01: col := row := 0
           $08: if col
                  col--
                  BackSpace(BackSpaceColor)
           $09: repeat
                  print(" ")
                while col & 7
           $0A..$0C: flag := c
                     return
           $0D: newline
           other: print(c)
    $0A: col := c // cols
    $0B: row := c // rows
    $0C: color := c & 7
  flag := 0


PRI print(c)  
   case nFont
     0: case c
          $20: ' espacio
          $27: '"
              Show(string("comib.btx"),col*8+32768,8,row*11,11)
          $2A: '*
              Show(string("asteb.btx"),col*8+32768,8,row*11,11)
          $2B: '+
              Show(string("masb.btx"),col*8+32768,8,row*11,11)
          $2C: ',
              Show(string("comab.btx"),col*8+32768,8,row*11,11)
          $2D: '-
              Show(string("menosb.btx"),col*8+32768,8,row*11,11)
          $2E: '.
              Show(string("puntob.btx"),col*8+32768,8,row*11,11)
          $3A: ':
              Show(string("dpunb.btx"),col*8+32768,8,row*11,11)
          $3B: ';
              Show(string("pcomb.btx"),col*8+32768,8,row*11,11)
          $3C: '<
              Show(string("menorb.btx"),col*8+32768,8,row*11,11)
          $3D: '=
              Show(string("igualb.btx"),col*8+32768,8,row*11,11)
          $3E: '>
              Show(string("mayorb.btx"),col*8+32768,8,row*11,11)
          $3F: '?
              Show(string("inteb.btx"),col*8+32768,8,row*11,11)
       
          $D1: '
              Show(string("enemac.btx"),col*8+32768,8,row*11,11)
          $E1: '
              Show(string("aceac.btx"),col*8+32768,8,row*11,11)
          $E9: '
              Show(string("aceec.btx"),col*8+32768,8,row*11,11)
          $ED: '
              Show(string("aceic.btx"),col*8+32768,8,row*11,11)
          $F1: '
              Show(string("enemic.btx"),col*8+32768,8,row*11,11)
          $F3: '
              Show(string("aceoc.btx"),col*8+32768,8,row*11,11)
          $FA: '
              Show(string("aceuc.btx"),col*8+32768,8,row*11,11)
          other:
              textbuf[0]:=c
              if c => $61
                 textbuf[1] := byte[string("c")]
              else
                 textbuf[1] := byte[string("b")]  
              Show(@textbuf,col*8+32768,8,row*11,11)
     1: case c
          $20: ' espacio
          $27: '"
              Show(string("comid.btx"),col*17+32768,17,row*16,16)
          $2A: '*
              Show(string("asted.btx"),col*17+32768,17,row*16,16)
          $2B: '+
              Show(string("masd.btx"),col*17+32768,17,row*16,16)
          $2C: ',
              Show(string("comad.btx"),col*17+32768,17,row*16,16)
          $2D: '-
              Show(string("menosd.btx"),col*17+32768,17,row*16,16)
          $2E: '.
              Show(string("puntod.btx"),col*17+32768,17,row*16,16)
          $3A: ':
              Show(string("dpund.btx"),col*17+32768,17,row*16,16)
          $3B: ';
              Show(string("pcomd.btx"),col*17+32768,17,row*16,16)
          $3C: '<
              Show(string("menord.btx"),col*17+32768,17,row*16,16)
          $3D: '=
              Show(string("iguald.btx"),col*17+32768,17,row*16,16)
          $3E: '>
              Show(string("mayord.btx"),col*17+32768,17,row*16,16)
          $3F: '?
              Show(string("inted.btx"),col*17+32768,17,row*16,16)
       
          $D1: '
              Show(string("enemae.btx"),col*17+32768,17,row*16,16)
          $E1: '
              Show(string("aceae.btx"),col*17+32768,17,row*16,16)
          $E9: '
              Show(string("aceee.btx"),col*17+32768,17,row*16,16)
          $ED: '
              Show(string("aceie.btx"),col*17+32768,17,row*16,16)
          $F1: '
              Show(string("enemie.btx"),col*17+32768,17,row*16,16)
          $F3: '
              Show(string("aceoe.btx"),col*17+32768,17,row*16,16)
          $FA: '
              Show(string("aceue.btx"),col*17+32768,17,row*16,16)
          other:
              textbuf[0]:=c
              if c => $61
                 textbuf[1] := byte[string("e")]
              else
                 textbuf[1] := byte[string("d")]  
              Show(@textbuf,col*17+32768,17,row*16,16)
       
  if ++col == cols
     newline

PRI newline | i

  col := 0
  row++

DAT
'*****************************************************************************************
''      MIT LICENSE
{{
'  Permission is hereby granted, free of charge, to any person obtaining
'  a copy of this software and associated documentation files
'  (the "Software"), to deal in the Software without restriction,
'  including without limitation the rights to use, copy, modify, merge,
'  publish, distribute, sublicense, and/or sell copies of the Software,
'  and to permit persons to whom the Software is furnished to do so,
'  subject to the following conditions:
'
'  The above copyright notice and this permission notice shall be included
'  in all copies or substantial portions of the Software.
'
'  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
'  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
'  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
'  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
'  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
'  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
'  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
}}         